'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _groupArray;

function _load_groupArray() {
  return _groupArray = _interopRequireDefault(require('group-array'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _stringFormat;

function _load_stringFormat() {
  return _stringFormat = _interopRequireDefault(require('string-format'));
}

var _lodash;

function _load_lodash() {
  return _lodash = _interopRequireDefault(require('lodash.partition'));
}

var _consumerLocator;

function _load_consumerLocator() {
  return _consumerLocator = require('./consumer-locator');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _driver;

function _load_driver() {
  return _driver = require('../driver');
}

var _driverNotFound;

function _load_driverNotFound() {
  return _driverNotFound = _interopRequireDefault(require('../driver/exceptions/driver-not-found'));
}

var _consumerBitJson;

function _load_consumerBitJson() {
  return _consumerBitJson = _interopRequireDefault(require('./bit-json/consumer-bit-json'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('./component'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _scope;

function _load_scope() {
  return _scope = require('../scope');
}

var _consumerMigratorManifest;

function _load_consumerMigratorManifest() {
  return _consumerMigratorManifest = _interopRequireDefault(require('./migrations/consumer-migrator-manifest'));
}

var _consumerMigrator;

function _load_consumerMigrator() {
  return _consumerMigrator = _interopRequireDefault(require('./migrations/consumer-migrator'));
}

var _consumerMigrator2;

function _load_consumerMigrator2() {
  return _consumerMigrator2 = require('./migrations/consumer-migrator');
}

var _enrichContextFromGlobal;

function _load_enrichContextFromGlobal() {
  return _enrichContextFromGlobal = _interopRequireDefault(require('../hooks/utils/enrich-context-from-global'));
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../cli/loader'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../cli/loader/loader-messages');
}

var _bitMap;

function _load_bitMap() {
  return _bitMap = _interopRequireDefault(require('./bit-map/bit-map'));
}

var _componentMap;

function _load_componentMap() {
  return _componentMap = _interopRequireDefault(require('./bit-map/component-map'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('./bit-map/exceptions');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _dirStructure;

function _load_dirStructure() {
  return _dirStructure = _interopRequireDefault(require('./dir-structure/dir-structure'));
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _dependenciesResolver;

function _load_dependenciesResolver() {
  return _dependenciesResolver = _interopRequireDefault(require('./component/dependencies-resolver'));
}

var _models;

function _load_models() {
  return _models = require('../scope/models');
}

var _missingFilesFromComponent;

function _load_missingFilesFromComponent() {
  return _missingFilesFromComponent = _interopRequireDefault(require('./component/exceptions/missing-files-from-component'));
}

var _componentNotFoundInPath;

function _load_componentNotFoundInPath() {
  return _componentNotFoundInPath = _interopRequireDefault(require('./component/exceptions/component-not-found-in-path'));
}

var _npmClient;

function _load_npmClient() {
  return _npmClient = _interopRequireDefault(require('../npm-client'));
}

var _componentRemove;

function _load_componentRemove() {
  return _componentRemove = require('../scope/component-remove');
}

var _links;

function _load_links() {
  return _links = require('../links');
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../api/consumer/lib/global-config');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Consumer = function () {
  // cache loaded components

  function Consumer(_ref) {
    var projectPath = _ref.projectPath,
        bitJson = _ref.bitJson,
        scope = _ref.scope,
        _ref$created = _ref.created,
        created = _ref$created === undefined ? false : _ref$created;

    _classCallCheck(this, Consumer);

    this._componentsCache = {};
    this._componentsStatusCache = {};

    this.projectPath = projectPath;
    this.bitJson = bitJson;
    this.created = created;
    this.scope = scope;
    this.warnForMissingDriver();
  } // cache loaded components


  _createClass(Consumer, [{
    key: 'getBitMap',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this._bitMap) {
                  _context.next = 4;
                  break;
                }

                _context.next = 3;
                return (_bitMap || _load_bitMap()).default.load(this.getPath());

              case 3:
                this._bitMap = _context.sent;

              case 4:
                return _context.abrupt('return', this._bitMap);

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getBitMap() {
        return _ref2.apply(this, arguments);
      }

      return getBitMap;
    }()

    /**
     * Check if the driver installed and print message if not
     *
     *
     * @param {any} msg msg to print in case the driver not found (use string-format with the err context)
     * @returns {boolean} true if the driver exists, false otherwise
     * @memberof Consumer
     */

  }, {
    key: 'warnForMissingDriver',
    value: function warnForMissingDriver(msg) {
      try {
        this.driver.getDriver(false);
        return true;
      } catch (err) {
        msg = msg ? (0, (_stringFormat || _load_stringFormat()).default)(msg, err) : `Warning: Bit is not be able to run the link command. Please install bit-${err.lang} driver and run the link command.`;
        if (err instanceof (_driverNotFound || _load_driverNotFound()).default) {
          console.log((_chalk || _load_chalk()).default.yellow(msg)); // eslint-disable-line
        }
        return false;
      }
    }

    /**
     * Running migration process for consumer to update the stores (.bit.map.json) to the current version
     *
     * @param {any} verbose - print debug logs
     * @returns {Object} - wether the process run and wether it successeded
     * @memberof Consumer
     */

  }, {
    key: 'migrate',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(verbose) {
        var bitMap, bitmapVersion, result;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_logger || _load_logger()).default.debug('running migration process for consumer');
                // Check version of stores (bitmap / bitjson) to check if we need to run migrate
                // If migration is needed add loader - loader.start(BEFORE_MIGRATION);
                // bitmap migrate
                if (verbose) console.log('running migration process for consumer'); // eslint-disable-line
                // We start to use this process after version 0.10.9, so we assume the scope is in the last production version
                _context2.next = 4;
                return this.getBitMap();

              case 4:
                bitMap = _context2.sent;
                bitmapVersion = bitMap.version || '0.10.9';

                if (!(_semver || _load_semver()).default.gte(bitmapVersion, (_constants || _load_constants()).BIT_VERSION)) {
                  _context2.next = 9;
                  break;
                }

                (_logger || _load_logger()).default.debug('bit.map version is up to date');
                return _context2.abrupt('return', {
                  run: false
                });

              case 9:

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_MIGRATION);

                _context2.next = 12;
                return (0, (_consumerMigrator || _load_consumerMigrator()).default)(bitmapVersion, (_consumerMigratorManifest || _load_consumerMigratorManifest()).default, bitMap, verbose);

              case 12:
                result = _context2.sent;

                result.bitMap.version = (_constants || _load_constants()).BIT_VERSION;
                _context2.next = 16;
                return result.bitMap.write();

              case 16:
                return _context2.abrupt('return', {
                  run: true,
                  success: true
                });

              case 17:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function migrate(_x) {
        return _ref3.apply(this, arguments);
      }

      return migrate;
    }()
  }, {
    key: 'write',
    value: function write() {
      var _this = this;

      return this.bitJson.write({ bitDir: this.projectPath }).then(function () {
        return _this.scope.ensureDir();
      }).then(function () {
        return _this;
      });
    }
  }, {
    key: 'getComponentsPath',
    value: function getComponentsPath() {
      return (_path || _load_path()).default.join(this.projectPath, (_constants || _load_constants()).BITS_DIRNAME);
    }
  }, {
    key: 'getPath',
    value: function getPath() {
      return this.projectPath;
    }
  }, {
    key: 'getPathRelativeToConsumer',
    value: function getPathRelativeToConsumer(pathToCheck) {
      var absolutePath = (_path || _load_path()).default.resolve(pathToCheck);
      return (_path || _load_path()).default.relative(this.getPath(), absolutePath);
    }
  }, {
    key: 'loadComponent',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(id) {
        var _ref5, components;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.loadComponents([id]);

              case 2:
                _ref5 = _context3.sent;
                components = _ref5.components;
                return _context3.abrupt('return', components[0]);

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function loadComponent(_x2) {
        return _ref4.apply(this, arguments);
      }

      return loadComponent;
    }()
  }, {
    key: 'loadComponents',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(ids) {
        var _this2 = this;

        var throwOnFailure = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        var alreadyLoadedComponents, idsToProcess, deletedComponents, bitMap, driverExists, components, allComponents, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, componentP, component;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`loading consumer-components from the file-system, ids: ${ids.join(', ')}`);
                alreadyLoadedComponents = [];
                idsToProcess = [];
                deletedComponents = [];

                ids.forEach(function (id) {
                  if (_this2._componentsCache[id.toString()]) {
                    (_logger || _load_logger()).default.debug(`the component ${id.toString()} has been already loaded, use the cached component`);
                    alreadyLoadedComponents.push(_this2._componentsCache[id.toString()]);
                  } else {
                    idsToProcess.push(id);
                  }
                });

                if (idsToProcess.length) {
                  _context5.next = 7;
                  break;
                }

                return _context5.abrupt('return', { components: alreadyLoadedComponents, deletedComponents });

              case 7:
                _context5.next = 9;
                return this.getBitMap();

              case 9:
                bitMap = _context5.sent;
                driverExists = this.warnForMissingDriver('Warning: Bit is not be able calculate the dependencies tree. Please install bit-{lang} driver and run commit again.');
                components = idsToProcess.map(function () {
                  var _ref7 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(id) {
                    var idWithConcreteVersionString, idWithConcreteVersion, componentMap, bitDir, componentFromModel, component;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            idWithConcreteVersionString = (0, (_utils || _load_utils()).getLatestVersionNumber)(Object.keys(bitMap.getAllComponents()), id.toString());
                            idWithConcreteVersion = (_bitId || _load_bitId()).BitId.parse(idWithConcreteVersionString);
                            componentMap = bitMap.getComponent(idWithConcreteVersion, true);
                            bitDir = _this2.getPath();

                            if (componentMap.rootDir) {
                              bitDir = (_path || _load_path()).default.join(bitDir, componentMap.rootDir);
                            }
                            _context4.next = 7;
                            return _this2.scope.getFromLocalIfExist(idWithConcreteVersion);

                          case 7:
                            componentFromModel = _context4.sent;
                            component = void 0;
                            _context4.prev = 9;
                            _context4.next = 12;
                            return (_component || _load_component()).default.loadFromFileSystem({
                              bitDir,
                              consumerBitJson: _this2.bitJson,
                              componentMap,
                              id: idWithConcreteVersion,
                              consumerPath: _this2.getPath(),
                              bitMap,
                              componentFromModel
                            });

                          case 12:
                            component = _context4.sent;
                            _context4.next = 24;
                            break;

                          case 15:
                            _context4.prev = 15;
                            _context4.t0 = _context4['catch'](9);

                            if (!throwOnFailure) {
                              _context4.next = 19;
                              break;
                            }

                            throw _context4.t0;

                          case 19:

                            (_logger || _load_logger()).default.error(`failed loading ${id} from the file-system`);

                            if (!(_context4.t0 instanceof (_missingFilesFromComponent || _load_missingFilesFromComponent()).default || _context4.t0 instanceof (_componentNotFoundInPath || _load_componentNotFoundInPath()).default)) {
                              _context4.next = 23;
                              break;
                            }

                            deletedComponents.push(id);
                            return _context4.abrupt('return', null);

                          case 23:
                            throw _context4.t0;

                          case 24:
                            component.originallySharedDir = componentMap.originallySharedDir || null;

                            if (!(!driverExists || componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED)) {
                              _context4.next = 27;
                              break;
                            }

                            return _context4.abrupt('return', component);

                          case 27:
                            return _context4.abrupt('return', (0, (_dependenciesResolver || _load_dependenciesResolver()).default)(component, componentMap, bitDir, _this2, bitMap, idWithConcreteVersionString, componentFromModel));

                          case 28:
                          case 'end':
                            return _context4.stop();
                        }
                      }
                    }, _callee4, _this2, [[9, 15]]);
                  }));

                  return function (_x5) {
                    return _ref7.apply(this, arguments);
                  };
                }());
                allComponents = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context5.prev = 16;
                _iterator = components[Symbol.iterator]();

              case 18:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context5.next = 27;
                  break;
                }

                componentP = _step.value;
                _context5.next = 22;
                return componentP;

              case 22:
                component = _context5.sent;

                if (component) {
                  this._componentsCache[component.id.toString()] = component;
                  (_logger || _load_logger()).default.debug(`Finished loading the component, ${component.id.toString()}`);
                  allComponents.push(component);
                }

              case 24:
                _iteratorNormalCompletion = true;
                _context5.next = 18;
                break;

              case 27:
                _context5.next = 33;
                break;

              case 29:
                _context5.prev = 29;
                _context5.t0 = _context5['catch'](16);
                _didIteratorError = true;
                _iteratorError = _context5.t0;

              case 33:
                _context5.prev = 33;
                _context5.prev = 34;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 36:
                _context5.prev = 36;

                if (!_didIteratorError) {
                  _context5.next = 39;
                  break;
                }

                throw _iteratorError;

              case 39:
                return _context5.finish(36);

              case 40:
                return _context5.finish(33);

              case 41:
                if (!bitMap.hasChanged) {
                  _context5.next = 44;
                  break;
                }

                _context5.next = 44;
                return bitMap.write();

              case 44:
                return _context5.abrupt('return', { components: allComponents.concat(alreadyLoadedComponents), deletedComponents });

              case 45:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this, [[16, 29, 33, 41], [34,, 36, 40]]);
      }));

      function loadComponents(_x4) {
        return _ref6.apply(this, arguments);
      }

      return loadComponents;
    }()
  }, {
    key: 'importAccordingToBitJsonAndBitMap',
    value: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(verbose, withEnvironments) {
        var cache = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var withPackageJson = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
        var force = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
        var dist = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
        var conf = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
        var installNpmPackages = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : true;
        var saveDependenciesAsComponents = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : false;
        var dependenciesFromBitJson, bitMap, componentsFromBitMap, allComponentsIds, componentsAndDependenciesBitJson, componentsAndDependenciesBitMap, componentsAndDependencies, envComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                dependenciesFromBitJson = (_bitId || _load_bitId()).BitIds.fromObject(this.bitJson.dependencies);
                _context6.next = 3;
                return this.getBitMap();

              case 3:
                bitMap = _context6.sent;
                componentsFromBitMap = bitMap.getAuthoredExportedComponents();

                if (!(((_ramda || _load_ramda()).default.isNil(dependenciesFromBitJson) || (_ramda || _load_ramda()).default.isEmpty(dependenciesFromBitJson)) && (_ramda || _load_ramda()).default.isEmpty(componentsFromBitMap))) {
                  _context6.next = 12;
                  break;
                }

                if (withEnvironments) {
                  _context6.next = 10;
                  break;
                }

                return _context6.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).NothingToImport()));

              case 10:
                if (!((_ramda || _load_ramda()).default.isNil(this.testerId) && (_ramda || _load_ramda()).default.isNil(this.compilerId))) {
                  _context6.next = 12;
                  break;
                }

                return _context6.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).NothingToImport()));

              case 12:
                if (force) {
                  _context6.next = 16;
                  break;
                }

                allComponentsIds = dependenciesFromBitJson.concat(componentsFromBitMap);
                _context6.next = 16;
                return this.warnForModifiedComponents(allComponentsIds);

              case 16:
                componentsAndDependenciesBitJson = [];
                componentsAndDependenciesBitMap = [];

                if (!dependenciesFromBitJson) {
                  _context6.next = 24;
                  break;
                }

                _context6.next = 21;
                return this.scope.getManyWithAllVersions(dependenciesFromBitJson, cache);

              case 21:
                componentsAndDependenciesBitJson = _context6.sent;
                _context6.next = 24;
                return this.writeToComponentsDir({
                  componentsWithDependencies: componentsAndDependenciesBitJson,
                  withPackageJson,
                  withBitJson: conf,
                  dist,
                  saveDependenciesAsComponents,
                  installNpmPackages,
                  verbose
                });

              case 24:
                if (!componentsFromBitMap.length) {
                  _context6.next = 30;
                  break;
                }

                _context6.next = 27;
                return this.scope.getManyWithAllVersions(componentsFromBitMap, cache);

              case 27:
                componentsAndDependenciesBitMap = _context6.sent;
                _context6.next = 30;
                return this.writeToComponentsDir({
                  componentsWithDependencies: componentsAndDependenciesBitMap,
                  force: false,
                  withPackageJson: false,
                  installNpmPackages: false,
                  withBitJson: conf,
                  dist
                });

              case 30:
                componentsAndDependencies = [].concat(_toConsumableArray(componentsAndDependenciesBitJson), _toConsumableArray(componentsAndDependenciesBitMap));

                if (!withEnvironments) {
                  _context6.next = 36;
                  break;
                }

                _context6.next = 34;
                return this.scope.installEnvironment({
                  ids: [this.testerId, this.compilerId],
                  verbose
                });

              case 34:
                envComponents = _context6.sent;
                return _context6.abrupt('return', {
                  dependencies: componentsAndDependencies,
                  envDependencies: envComponents
                });

              case 36:
                return _context6.abrupt('return', { dependencies: componentsAndDependencies });

              case 37:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function importAccordingToBitJsonAndBitMap(_x13, _x14) {
        return _ref8.apply(this, arguments);
      }

      return importAccordingToBitJsonAndBitMap;
    }()
  }, {
    key: 'warnForModifiedComponents',
    value: function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(ids) {
        var _this3 = this;

        var modifiedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return (0, (_utils || _load_utils()).filterAsync)(ids, function (id) {
                  return _this3.getComponentStatusById(id).then(function (status) {
                    return status.modified;
                  });
                });

              case 2:
                modifiedComponents = _context7.sent;

                if (!modifiedComponents.length) {
                  _context7.next = 5;
                  break;
                }

                return _context7.abrupt('return', Promise.reject((_chalk || _load_chalk()).default.yellow(`unable to import the following components due to local changes, use --force flag to override your local changes\n${modifiedComponents.join('\n')} `)));

              case 5:
                return _context7.abrupt('return', Promise.resolve());

              case 6:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function warnForModifiedComponents(_x15) {
        return _ref9.apply(this, arguments);
      }

      return warnForModifiedComponents;
    }()
  }, {
    key: 'importSpecificComponents',
    value: function () {
      var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(rawIds, cache, writeToPath) {
        var withPackageJson = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
        var writeBitDependencies = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
        var force = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
        var verbose = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
        var dist = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
        var conf = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : false;
        var installNpmPackages = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : true;
        var saveDependenciesAsComponents = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : false;
        var bitIds, componentsWithDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`importSpecificComponents, Ids: ${rawIds.join(', ')}`);
                // $FlowFixMe - we check if there are bitIds before we call this function
                bitIds = rawIds.map(function (raw) {
                  return (_bitId || _load_bitId()).BitId.parse(raw);
                });

                if (force) {
                  _context8.next = 5;
                  break;
                }

                _context8.next = 5;
                return this.warnForModifiedComponents(bitIds);

              case 5:
                _context8.next = 7;
                return this.scope.getManyWithAllVersions(bitIds, cache);

              case 7:
                componentsWithDependencies = _context8.sent;
                _context8.next = 10;
                return this.writeToComponentsDir({
                  componentsWithDependencies,
                  writeToPath,
                  withPackageJson,
                  withBitJson: conf,
                  writeBitDependencies,
                  dist,
                  saveDependenciesAsComponents,
                  installNpmPackages,
                  verbose
                });

              case 10:
                return _context8.abrupt('return', { dependencies: componentsWithDependencies });

              case 11:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function importSpecificComponents(_x24, _x25, _x26) {
        return _ref10.apply(this, arguments);
      }

      return importSpecificComponents;
    }()
  }, {
    key: 'import',
    value: function _import(rawIds, verbose, withEnvironments) {
      var cache = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var writeToPath = arguments[4];
      var withPackageJson = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : true;
      var writeBitDependencies = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
      var force = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
      var dist = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : false;
      var conf = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : false;
      var installNpmPackages = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : true;

      (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ACTION);
      var saveDependenciesAsComponents = this.bitJson.saveDependenciesAsComponents;
      if (!withPackageJson) {
        // if package.json is not written, it's impossible to install the packages and dependencies as npm packages
        installNpmPackages = false;
        saveDependenciesAsComponents = true;
      }
      if (!installNpmPackages) {
        // if npm packages are not installed, don't install dependencies as npm packages
        saveDependenciesAsComponents = true;
      }
      if (!rawIds || (_ramda || _load_ramda()).default.isEmpty(rawIds)) {
        return this.importAccordingToBitJsonAndBitMap(verbose, withEnvironments, cache, withPackageJson, force, dist, conf, installNpmPackages, saveDependenciesAsComponents);
      }
      return this.importSpecificComponents(rawIds, cache, writeToPath, withPackageJson, writeBitDependencies, force, verbose, dist, conf, installNpmPackages, saveDependenciesAsComponents);
    }
  }, {
    key: 'importEnvironment',
    value: function importEnvironment(rawId, verbose) {
      if (!rawId) {
        throw new Error('you must specify bit id for importing');
      } // @TODO - make a normal error message
      var bitId = (_bitId || _load_bitId()).BitId.parse(rawId);
      return this.scope.installEnvironment({ ids: [bitId], verbose }).then(function (envDependencies) {
        // todo: do we need the environment in bit.map?
        // this.bitMap.addComponent(bitId.toString(), this.composeRelativeBitPath(bitId));
        // this.bitMap.write();
        return envDependencies;
      });
    }
  }, {
    key: 'removeFromComponents',
    value: function removeFromComponents(id) {
      var currentVersionOnly = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var componentsDir = this.getComponentsPath();
      var componentDir = (_path || _load_path()).default.join(componentsDir, id.box, id.name, id.scope, currentVersionOnly ? id.version : '');

      return new Promise(function (resolve, reject) {
        return (_fsExtra || _load_fsExtra()).default.remove(componentDir, function (err) {
          if (err) return reject(err);
          return resolve();
        });
      });
    }

    /**
     * write the components into '/components' dir (or according to the bit.map) and its dependencies in the
     * '/components/.dependencies' dir. Both directories are configurable in bit.json
     * For example: global/a has a dependency my-scope/global/b@1. The directories will be:
     * project/root/components/global/a/impl.js
     * project/root/components/.dependencies/global/b/my-scope/1/impl.js
     *
     * In case there are some same dependencies shared between the components, it makes sure to
     * write them only once.
     */

  }, {
    key: 'writeToComponentsDir',
    value: function () {
      var _ref12 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9(_ref11) {
        var _this4 = this;

        var componentsWithDependencies = _ref11.componentsWithDependencies,
            writeToPath = _ref11.writeToPath,
            _ref11$force = _ref11.force,
            force = _ref11$force === undefined ? true : _ref11$force,
            _ref11$withPackageJso = _ref11.withPackageJson,
            withPackageJson = _ref11$withPackageJso === undefined ? true : _ref11$withPackageJso,
            _ref11$withBitJson = _ref11.withBitJson,
            withBitJson = _ref11$withBitJson === undefined ? true : _ref11$withBitJson,
            _ref11$writeBitDepend = _ref11.writeBitDependencies,
            writeBitDependencies = _ref11$writeBitDepend === undefined ? false : _ref11$writeBitDepend,
            _ref11$createNpmLinkF = _ref11.createNpmLinkFiles,
            createNpmLinkFiles = _ref11$createNpmLinkF === undefined ? false : _ref11$createNpmLinkF,
            _ref11$dist = _ref11.dist,
            dist = _ref11$dist === undefined ? true : _ref11$dist,
            _ref11$saveDependenci = _ref11.saveDependenciesAsComponents,
            saveDependenciesAsComponents = _ref11$saveDependenci === undefined ? false : _ref11$saveDependenci,
            _ref11$installNpmPack = _ref11.installNpmPackages,
            installNpmPackages = _ref11$installNpmPack === undefined ? true : _ref11$installNpmPack,
            _ref11$verbose = _ref11.verbose,
            verbose = _ref11$verbose === undefined ? false : _ref11$verbose;
        var bitMap, dependenciesIdsCache, remotes, writeComponentsP, writtenComponents, allDependenciesP, writtenDependenciesIncludesNull, writtenDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getBitMap();

              case 2:
                bitMap = _context9.sent;
                dependenciesIdsCache = [];
                _context9.next = 6;
                return this.scope.remotes();

              case 6:
                remotes = _context9.sent;
                writeComponentsP = componentsWithDependencies.map(function (componentWithDeps) {
                  var bitDir = writeToPath || _this4.composeComponentPath(componentWithDeps.component.id);
                  componentWithDeps.component.writtenPath = bitDir;
                  // if a component.scope is listed as a remote, it doesn't go to the hub and therefore it can't import dependencies as packages
                  componentWithDeps.component.dependenciesSavedAsComponents = saveDependenciesAsComponents || remotes.get(componentWithDeps.component.scope);
                  // AUTHORED and IMPORTED components can't be saved with multiple versions, so we can ignore the version to
                  // find the component in bit.map
                  var componentMap = bitMap.getComponent(componentWithDeps.component.id.toStringWithoutVersion(), false);
                  var origin = componentMap && componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED ? (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED : (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED;
                  if (origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED) {
                    componentWithDeps.component.stripOriginallySharedDir(bitMap);
                  }
                  // don't write dists files for authored components as the author has its own mechanism to generate them
                  // also, don't write dists file for imported component, unless the user used '--dist' flag
                  componentWithDeps.component._writeDistsFiles = dist && origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED;
                  return componentWithDeps.component.write({
                    bitDir,
                    force,
                    bitMap,
                    withBitJson,
                    withPackageJson,
                    origin,
                    consumer: _this4,
                    writeBitDependencies: writeBitDependencies || !componentWithDeps.component.dependenciesSavedAsComponents, // when dependencies are written as npm packages, they must be written in package.json
                    dependencies: componentWithDeps.dependencies,
                    componentMap
                  });
                });
                _context9.next = 10;
                return Promise.all(writeComponentsP);

              case 10:
                writtenComponents = _context9.sent;
                allDependenciesP = componentsWithDependencies.map(function (componentWithDeps) {
                  if (!componentWithDeps.component.dependenciesSavedAsComponents) return Promise.resolve(null);
                  var writeDependenciesP = componentWithDeps.dependencies.map(function (dep) {
                    var dependencyId = dep.id.toString();
                    var depFromBitMap = bitMap.getComponent(dependencyId, false);
                    if (depFromBitMap && (_fsExtra || _load_fsExtra()).default.existsSync(depFromBitMap.rootDir)) {
                      dep.writtenPath = depFromBitMap.rootDir;
                      (_logger || _load_logger()).default.debug(`writeToComponentsDir, ignore dependency ${dependencyId} as it already exists in bit map and file system`);
                      bitMap.addDependencyToParent(componentWithDeps.component.id, dependencyId);
                      return Promise.resolve(dep);
                    }
                    if (dependenciesIdsCache[dependencyId]) {
                      (_logger || _load_logger()).default.debug(`writeToComponentsDir, ignore dependency ${dependencyId} as it already exists in cache`);
                      dep.writtenPath = dependenciesIdsCache[dependencyId];
                      bitMap.addDependencyToParent(componentWithDeps.component.id, dependencyId);
                      return Promise.resolve(dep);
                    }
                    var depBitPath = _this4.composeDependencyPath(dep.id);
                    dep.writtenPath = depBitPath;
                    dependenciesIdsCache[dependencyId] = depBitPath;
                    // When a component is NESTED we do interested in the exact version, because multiple components with the same scope
                    // and namespace can co-exist with different versions.
                    var componentMap = bitMap.getComponent(dep.id.toString(), false);
                    return dep.write({
                      bitDir: depBitPath,
                      force,
                      bitMap,
                      withPackageJson,
                      origin: (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED,
                      parent: componentWithDeps.component.id,
                      consumer: _this4,
                      dependencies: dep.dependencies,
                      componentMap
                    });
                  });

                  return Promise.all(writeDependenciesP);
                });
                _context9.next = 14;
                return Promise.all(allDependenciesP);

              case 14:
                writtenDependenciesIncludesNull = _context9.sent;
                writtenDependencies = writtenDependenciesIncludesNull.filter(function (dep) {
                  return dep;
                });

                if (writeToPath) {
                  componentsWithDependencies.forEach(function (componentWithDeps) {
                    var relativeWrittenPath = _this4.getPathRelativeToConsumer(componentWithDeps.component.writtenPath);
                    if (relativeWrittenPath && (_path || _load_path()).default.resolve(relativeWrittenPath) !== (_path || _load_path()).default.resolve(writeToPath)) {
                      var component = componentWithDeps.component;
                      _this4.moveExistingComponent(bitMap, component, relativeWrittenPath, writeToPath);
                    }
                  });
                }
                _context9.next = 19;
                return bitMap.write();

              case 19:
                if (!installNpmPackages) {
                  _context9.next = 22;
                  break;
                }

                _context9.next = 22;
                return this.installNpmPackages(componentsWithDependencies, verbose);

              case 22:
                _context9.next = 24;
                return this.addComponentsToRootPackageJson(writtenComponents, bitMap);

              case 24:
                return _context9.abrupt('return', (0, (_links || _load_links()).linkComponents)(componentsWithDependencies, writtenComponents, writtenDependencies, bitMap, this, createNpmLinkFiles));

              case 25:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function writeToComponentsDir(_x35) {
        return _ref12.apply(this, arguments);
      }

      return writeToComponentsDir;
    }()
  }, {
    key: 'addComponentsToRootPackageJson',
    value: function () {
      var _ref13 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(components, bitMap) {
        var _this5 = this;

        var importedComponents, driver, PackageJson, componentsToAdd, registryPrefix;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return (0, (_utils || _load_utils()).filterAsync)(components, function (component) {
                  var componentMap = component.getComponentMap(bitMap);
                  return componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED;
                });

              case 2:
                importedComponents = _context10.sent;

                if (!(!importedComponents || !importedComponents.length)) {
                  _context10.next = 5;
                  break;
                }

                return _context10.abrupt('return');

              case 5:
                _context10.next = 7;
                return this.driver.getDriver(false);

              case 7:
                driver = _context10.sent;
                PackageJson = driver.PackageJson;
                componentsToAdd = (_ramda || _load_ramda()).default.fromPairs(importedComponents.map(function (component) {
                  var locationRelativeToConsumer = _this5.getPathRelativeToConsumer(component.writtenPath);
                  var locationAsUnixFormat = `./${(0, (_utils || _load_utils()).pathNormalizeToLinux)(locationRelativeToConsumer)}`;
                  return [component.id.toStringWithoutVersion(), locationAsUnixFormat];
                }));
                registryPrefix = Consumer.getRegistryPrefix();
                _context10.next = 13;
                return PackageJson.addComponentsIntoExistingPackageJson(this.getPath(), componentsToAdd, registryPrefix);

              case 13:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function addComponentsToRootPackageJson(_x36, _x37) {
        return _ref13.apply(this, arguments);
      }

      return addComponentsToRootPackageJson;
    }()
  }, {
    key: 'moveExistingComponent',
    value: function moveExistingComponent(bitMap, component, oldPath, newPath) {
      if ((_fsExtra || _load_fsExtra()).default.existsSync(newPath)) {
        throw new Error(`could not move the component ${component.id} from ${oldPath} to ${newPath} as the destination path already exists`);
      }
      var componentMap = bitMap.getComponent(component.id);
      componentMap.updateDirLocation(oldPath, newPath);
      (_fsExtra || _load_fsExtra()).default.moveSync(oldPath, newPath);
      component.writtenPath = newPath;
    }

    /**
     * By default, the dists paths are inside the component.
     * If dist attribute is populated in bit.json, the paths are in consumer-root/dist-target.
     */

  }, {
    key: 'shouldDistsBeInsideTheComponent',
    value: function shouldDistsBeInsideTheComponent() {
      return !this.bitJson.distEntry && !this.bitJson.distTarget;
    }
  }, {
    key: 'candidateComponentsForAutoTagging',
    value: function () {
      var _ref14 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee11(modifiedComponents) {
        var bitMap, candidateComponents, modifiedComponentsWithoutVersions, candidateComponentsIds;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.getBitMap();

              case 2:
                bitMap = _context11.sent;
                candidateComponents = bitMap.getAllComponents([(_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED, (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED]);

                if (candidateComponents) {
                  _context11.next = 6;
                  break;
                }

                return _context11.abrupt('return', null);

              case 6:
                modifiedComponentsWithoutVersions = modifiedComponents.map(function (modifiedComponent) {
                  return modifiedComponent.toStringWithoutVersion();
                });
                candidateComponentsIds = Object.keys(candidateComponents).map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                // if a modified component is in candidates array, remove it from the array as it will be already tagged with the
                // correct version

                return _context11.abrupt('return', candidateComponentsIds.filter(function (component) {
                  return !modifiedComponentsWithoutVersions.includes(component.toStringWithoutVersion());
                }));

              case 9:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function candidateComponentsForAutoTagging(_x38) {
        return _ref14.apply(this, arguments);
      }

      return candidateComponentsForAutoTagging;
    }()
  }, {
    key: 'listComponentsForAutoTagging',
    value: function () {
      var _ref15 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee12(modifiedComponents) {
        var candidateComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.candidateComponentsForAutoTagging(modifiedComponents);

              case 2:
                candidateComponents = _context12.sent;
                return _context12.abrupt('return', this.scope.bumpDependenciesVersions(candidateComponents, modifiedComponents, false));

              case 4:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function listComponentsForAutoTagging(_x39) {
        return _ref15.apply(this, arguments);
      }

      return listComponentsForAutoTagging;
    }()
  }, {
    key: 'bumpDependenciesVersions',
    value: function () {
      var _ref16 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee13(committedComponents) {
        var committedComponentsIds, candidateComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                committedComponentsIds = committedComponents.map(function (committedComponent) {
                  return committedComponent.id;
                });
                _context13.next = 3;
                return this.candidateComponentsForAutoTagging(committedComponentsIds);

              case 3:
                candidateComponents = _context13.sent;
                return _context13.abrupt('return', this.scope.bumpDependenciesVersions(candidateComponents, committedComponentsIds, true));

              case 5:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function bumpDependenciesVersions(_x40) {
        return _ref16.apply(this, arguments);
      }

      return bumpDependenciesVersions;
    }()

    /**
     * Check whether a model representation and file-system representation of the same component is the same.
     * The way how it is done is by converting the file-system representation of the component into
     * a Version object. Once this is done, we have two Version objects, and we can compare their hashes
     */

  }, {
    key: 'isComponentModified',
    value: function () {
      var _ref17 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee14(componentFromModel, componentFromFileSystem) {
        var bitMap, componentMap, _ref18, version;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                if (!(typeof componentFromFileSystem._isModified === 'undefined')) {
                  _context14.next = 14;
                  break;
                }

                _context14.next = 3;
                return this.getBitMap();

              case 3:
                bitMap = _context14.sent;
                componentMap = bitMap.getComponent(componentFromFileSystem.id, true);

                if (componentMap.originallySharedDir) {
                  componentFromFileSystem.originallySharedDir = componentMap.originallySharedDir;
                }
                _context14.next = 8;
                return this.scope.sources.consumerComponentToVersion({
                  consumerComponent: componentFromFileSystem
                });

              case 8:
                _ref18 = _context14.sent;
                version = _ref18.version;


                version.log = componentFromModel.log; // ignore the log, it's irrelevant for the comparison
                version.flattenedDependencies = componentFromModel.flattenedDependencies;
                // dependencies from the FS don't have an exact version, copy the version from the model
                version.dependencies.forEach(function (dependency) {
                  var idWithoutVersion = dependency.id.toStringWithoutVersion();
                  var dependencyFromModel = componentFromModel.dependencies.find(function (modelDependency) {
                    return modelDependency.id.toStringWithoutVersion() === idWithoutVersion;
                  });
                  if (dependencyFromModel) {
                    dependency.id = dependencyFromModel.id;
                  }
                });

                // uncomment to easily understand why two components are considered as modified
                // if (componentFromModel.hash().hash !== version.hash().hash) {
                //   console.log('-------------------componentFromModel------------------------');
                //   console.log(componentFromModel.id());
                //   console.log('------------------------version------------------------------');
                //   console.log(version.id());
                //   console.log('-------------------------END---------------------------------');
                // }
                componentFromFileSystem._isModified = componentFromModel.hash().hash !== version.hash().hash;

              case 14:
                return _context14.abrupt('return', componentFromFileSystem._isModified);

              case 15:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function isComponentModified(_x41, _x42) {
        return _ref17.apply(this, arguments);
      }

      return isComponentModified;
    }()

    /**
     * Get a component status by ID. Return a ComponentStatus object.
     * Keep in mind that a result can be a partial object of ComponentStatus, e.g. { notExist: true }.
     * Each one of the ComponentStatus properties can be undefined, true or false.
     * As a result, in order to check whether a component is not modified use (status.modified === false).
     * Don't use (!status.modified) because a component may not exist and the status.modified will be undefined.
     *
     * The status may have 'true' for several properties. For example, a component can be staged and modified at the
     * same time.
     *
     * The result is cached per ID and can be called several times with no penalties.
     */

  }, {
    key: 'getComponentStatusById',
    value: function () {
      var _ref19 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee16(id) {
        var _this6 = this;

        var getStatus;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                getStatus = function () {
                  var _ref20 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee15() {
                    var status, componentFromModel, componentFromFileSystem, versionFromFs, latestVersionFromModel, version, versionRef, versionFromModel;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee15$(_context15) {
                      while (1) {
                        switch (_context15.prev = _context15.next) {
                          case 0:
                            status = {};
                            _context15.next = 3;
                            return _this6.scope.sources.get(id);

                          case 3:
                            componentFromModel = _context15.sent;
                            componentFromFileSystem = void 0;
                            _context15.prev = 5;
                            _context15.next = 8;
                            return _this6.loadComponent((_bitId || _load_bitId()).BitId.parse(id.toStringWithoutVersion()));

                          case 8:
                            componentFromFileSystem = _context15.sent;
                            _context15.next = 17;
                            break;

                          case 11:
                            _context15.prev = 11;
                            _context15.t0 = _context15['catch'](5);

                            if (!(_context15.t0 instanceof (_missingFilesFromComponent || _load_missingFilesFromComponent()).default || _context15.t0 instanceof (_componentNotFoundInPath || _load_componentNotFoundInPath()).default || _context15.t0 instanceof (_exceptions2 || _load_exceptions2()).MissingBitMapComponent)) {
                              _context15.next = 16;
                              break;
                            }

                            // the file/s have been deleted or the component doesn't exist in bit.map file
                            if (componentFromModel) status.deleted = true;else status.notExist = true;
                            return _context15.abrupt('return', status);

                          case 16:
                            throw _context15.t0;

                          case 17:
                            if (componentFromModel) {
                              _context15.next = 20;
                              break;
                            }

                            status.newlyCreated = true;
                            return _context15.abrupt('return', status);

                          case 20:
                            // "!componentFromModel.scope" is for backward compatibility, and won't be needed for components created since v0.11.3.
                            status.staged = componentFromModel.local || !componentFromModel.scope;
                            versionFromFs = componentFromFileSystem.id.version;
                            latestVersionFromModel = componentFromModel.latest();
                            // Consider the following two scenarios:
                            // 1) a user tagged v1, exported, then tagged v2.
                            //    to check whether the component is modified, we've to compare FS to the v2 of the model, not v1.
                            // 2) a user imported v1 of a component from a remote, when the latest version on the remote is v2.
                            //    to check whether the component is modified, we've to compare FS to the v1 of the model, not v2.
                            //    @see reduce-path.e2e 'importing v1 of a component when a component has v2' to reproduce this case.

                            version = status.staged ? latestVersionFromModel : versionFromFs;
                            versionRef = componentFromModel.versions[version];
                            _context15.next = 27;
                            return _this6.scope.getObject(versionRef.hash);

                          case 27:
                            versionFromModel = _context15.sent;
                            _context15.next = 30;
                            return _this6.isComponentModified(versionFromModel, componentFromFileSystem);

                          case 30:
                            status.modified = _context15.sent;
                            return _context15.abrupt('return', status);

                          case 32:
                          case 'end':
                            return _context15.stop();
                        }
                      }
                    }, _callee15, _this6, [[5, 11]]);
                  }));

                  return function getStatus() {
                    return _ref20.apply(this, arguments);
                  };
                }();

                if (this._componentsStatusCache[id.toString()]) {
                  _context16.next = 5;
                  break;
                }

                _context16.next = 4;
                return getStatus();

              case 4:
                this._componentsStatusCache[id.toString()] = _context16.sent;

              case 5:
                return _context16.abrupt('return', this._componentsStatusCache[id.toString()]);

              case 6:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function getComponentStatusById(_x43) {
        return _ref19.apply(this, arguments);
      }

      return getComponentStatusById;
    }()
  }, {
    key: 'commit',
    value: function () {
      var _ref21 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee17(ids, message, exactVersion, releaseType, force, verbose, ignoreMissingDependencies) {
        var componentsIds, _ref22, components, componentsWithMissingDeps, committedComponents, autoUpdatedComponents;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`committing the following components: ${ids.join(', ')}`);
                componentsIds = ids.map(function (componentId) {
                  return (_bitId || _load_bitId()).BitId.parse(componentId);
                });
                _context17.next = 4;
                return this.loadComponents(componentsIds);

              case 4:
                _ref22 = _context17.sent;
                components = _ref22.components;

                if (ignoreMissingDependencies) {
                  _context17.next = 10;
                  break;
                }

                componentsWithMissingDeps = components.filter(function (component) {
                  return Boolean(component.missingDependencies);
                });

                if ((_ramda || _load_ramda()).default.isEmpty(componentsWithMissingDeps)) {
                  _context17.next = 10;
                  break;
                }

                throw new (_exceptions || _load_exceptions()).MissingDependencies(componentsWithMissingDeps);

              case 10:
                _context17.next = 12;
                return this.scope.putMany({
                  consumerComponents: components,
                  message,
                  exactVersion,
                  releaseType,
                  force,
                  consumer: this,
                  verbose
                });

              case 12:
                committedComponents = _context17.sent;
                _context17.next = 15;
                return this.bumpDependenciesVersions(committedComponents);

              case 15:
                autoUpdatedComponents = _context17.sent;
                return _context17.abrupt('return', { components, autoUpdatedComponents });

              case 17:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function commit(_x44, _x45, _x46, _x47, _x48, _x49, _x50) {
        return _ref21.apply(this, arguments);
      }

      return commit;
    }()
  }, {
    key: 'composeRelativeBitPath',
    value: function composeRelativeBitPath(bitId) {
      var componentsDefaultDirectory = this.dirStructure.componentsDefaultDirectory;

      return (0, (_stringFormat || _load_stringFormat()).default)(componentsDefaultDirectory, { name: bitId.name, scope: bitId.scope, namespace: bitId.box });
    }
  }, {
    key: 'composeComponentPath',
    value: function composeComponentPath(bitId) {
      var addToPath = [this.getPath(), this.composeRelativeBitPath(bitId)];
      (_logger || _load_logger()).default.debug(`component dir path: ${addToPath.join('/')}`);
      return (_path || _load_path()).default.join.apply((_path || _load_path()).default, addToPath);
    }
  }, {
    key: 'composeDependencyPath',
    value: function composeDependencyPath(bitId) {
      var dependenciesDir = this.dirStructure.dependenciesDirStructure;
      return (_path || _load_path()).default.join(this.getPath(), dependenciesDir, bitId.toFullPath());
    }
  }, {
    key: 'movePaths',
    value: function () {
      var _ref24 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee18(_ref23) {
        var from = _ref23.from,
            to = _ref23.to;
        var fromExists, toExists, fromRelative, toRelative, bitMap, changes;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                fromExists = (_fsExtra || _load_fsExtra()).default.existsSync(from);
                toExists = (_fsExtra || _load_fsExtra()).default.existsSync(to);

                if (!(fromExists && toExists)) {
                  _context18.next = 4;
                  break;
                }

                throw new Error(`unable to move because both paths from (${from}) and to (${to}) already exist`);

              case 4:
                if (!(!fromExists && !toExists)) {
                  _context18.next = 6;
                  break;
                }

                throw new Error(`both paths from (${from}) and to (${to}) do not exist`);

              case 6:
                fromRelative = this.getPathRelativeToConsumer(from);
                toRelative = this.getPathRelativeToConsumer(to);
                _context18.next = 10;
                return this.getBitMap();

              case 10:
                bitMap = _context18.sent;
                changes = bitMap.updatePathLocation(fromRelative, toRelative, fromExists);

                if (fromExists && !toExists) {
                  // user would like to physically move the file. Otherwise (!fromExists and toExists), user would like to only update bit.map
                  (_fsExtra || _load_fsExtra()).default.moveSync(from, to);
                }
                _context18.next = 15;
                return bitMap.write();

              case 15:
                return _context18.abrupt('return', changes);

              case 16:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function movePaths(_x51) {
        return _ref24.apply(this, arguments);
      }

      return movePaths;
    }()
  }, {
    key: 'deprecateRemote',
    value: function () {
      var _ref25 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee20(bitIds) {
        var _this7 = this;

        var groupedBitsByScope, remotes, context, deprecateP, deprecatedComponentsResult;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                groupedBitsByScope = (0, (_groupArray || _load_groupArray()).default)(bitIds, 'scope');
                _context20.next = 3;
                return this.scope.remotes();

              case 3:
                remotes = _context20.sent;
                context = {};

                (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
                deprecateP = Object.keys(groupedBitsByScope).map(function () {
                  var _ref26 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee19(scopeName) {
                    var resolvedRemote, deprecateResult;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee19$(_context19) {
                      while (1) {
                        switch (_context19.prev = _context19.next) {
                          case 0:
                            _context19.next = 2;
                            return remotes.resolve(scopeName, _this7.scope);

                          case 2:
                            resolvedRemote = _context19.sent;
                            _context19.next = 5;
                            return resolvedRemote.deprecateMany(groupedBitsByScope[scopeName], context);

                          case 5:
                            deprecateResult = _context19.sent;
                            return _context19.abrupt('return', deprecateResult);

                          case 7:
                          case 'end':
                            return _context19.stop();
                        }
                      }
                    }, _callee19, _this7);
                  }));

                  return function (_x53) {
                    return _ref26.apply(this, arguments);
                  };
                }());
                _context20.next = 9;
                return Promise.all(deprecateP);

              case 9:
                deprecatedComponentsResult = _context20.sent;
                return _context20.abrupt('return', deprecatedComponentsResult);

              case 11:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee20, this);
      }));

      function deprecateRemote(_x52) {
        return _ref25.apply(this, arguments);
      }

      return deprecateRemote;
    }()
  }, {
    key: 'deprecateLocal',
    value: function () {
      var _ref27 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee21(bitIds) {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                return _context21.abrupt('return', this.scope.deprecateMany(bitIds));

              case 1:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function deprecateLocal(_x54) {
        return _ref27.apply(this, arguments);
      }

      return deprecateLocal;
    }()
  }, {
    key: 'deprecate',
    value: function () {
      var _ref28 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee22(ids, remote) {
        var bitIds;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                bitIds = ids.map(function (bitId) {
                  return (_bitId || _load_bitId()).BitId.parse(bitId);
                });
                return _context22.abrupt('return', remote ? this.deprecateRemote(bitIds) : this.deprecateLocal(bitIds));

              case 2:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function deprecate(_x55, _x56) {
        return _ref28.apply(this, arguments);
      }

      return deprecate;
    }()

    /**
     * Remove components local and remote
     * splits array of ids into local and remote and removes according to flags
     * @param {string[]} ids - list of remote component ids to delete
     * @param {boolean} force - delete component that are used by other components.
     * @param {boolean} track - keep tracking local staged components in bitmap.
     * @param {boolean} deleteFiles - delete local added files from fs.
     */

  }, {
    key: 'remove',
    value: function () {
      var _ref29 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee23(ids, force, track, deleteFiles) {
        var bitIds, _partition, _partition2, localIds, remoteIds, localResult, remoteResult;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                // added this to remove support for remove version
                bitIds = ids.map(function (bitId) {
                  return (_bitId || _load_bitId()).BitId.parse(bitId);
                }).map(function (id) {
                  id.version = (_constants || _load_constants()).LATEST_BIT_VERSION;
                  return id;
                });
                _partition = (0, (_lodash || _load_lodash()).default)(bitIds, function (id) {
                  return id.isLocal();
                }), _partition2 = _slicedToArray(_partition, 2), localIds = _partition2[0], remoteIds = _partition2[1];
                _context23.next = 4;
                return this.removeLocal(localIds, force, track, deleteFiles);

              case 4:
                localResult = _context23.sent;
                _context23.next = 7;
                return this.removeRemote(remoteIds, force);

              case 7:
                remoteResult = _context23.sent;
                return _context23.abrupt('return', { localResult, remoteResult });

              case 9:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function remove(_x57, _x58, _x59, _x60) {
        return _ref29.apply(this, arguments);
      }

      return remove;
    }()

    /**
     * Remove remote component from ssh server
     * this method groups remote components by remote name and deletes remote components together
     * @param {BitIds} bitIds - list of remote component ids to delete
     * @param {boolean} force - delete component that are used by other components.
     */

  }, {
    key: 'removeRemote',
    value: function () {
      var _ref30 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee25(bitIds, force) {
        var _this8 = this;

        var groupedBitsByScope, remotes, context, removeP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                groupedBitsByScope = (0, (_groupArray || _load_groupArray()).default)(bitIds, 'scope');
                _context25.next = 3;
                return this.scope.remotes();

              case 3:
                remotes = _context25.sent;
                context = {};

                (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
                removeP = Object.keys(groupedBitsByScope).map(function () {
                  var _ref31 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee24(key) {
                    var resolvedRemote, result;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee24$(_context24) {
                      while (1) {
                        switch (_context24.prev = _context24.next) {
                          case 0:
                            _context24.next = 2;
                            return remotes.resolve(key, _this8.scope);

                          case 2:
                            resolvedRemote = _context24.sent;
                            _context24.next = 5;
                            return resolvedRemote.deleteMany(groupedBitsByScope[key], force, context);

                          case 5:
                            result = _context24.sent;
                            return _context24.abrupt('return', result);

                          case 7:
                          case 'end':
                            return _context24.stop();
                        }
                      }
                    }, _callee24, _this8);
                  }));

                  return function (_x63) {
                    return _ref31.apply(this, arguments);
                  };
                }());
                return _context25.abrupt('return', Promise.all(removeP));

              case 8:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee25, this);
      }));

      function removeRemote(_x61, _x62) {
        return _ref30.apply(this, arguments);
      }

      return removeRemote;
    }()
    /**
     * delete files from fs according to imported/created
     * @param {BitIds} bitIds - list of remote component ids to delete
     * @param {BitMap} bitMap - delete component that are used by other components.
     * @param {boolean} deleteFiles - delete component that are used by other components.
     */

  }, {
    key: 'removeComponentFromFs',
    value: function () {
      var _ref32 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee27(bitIds, bitMap, deleteFiles) {
        var _this9 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                return _context27.abrupt('return', Promise.all(bitIds.map(function () {
                  var _ref33 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee26(id) {
                    var component;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee26$(_context26) {
                      while (1) {
                        switch (_context26.prev = _context26.next) {
                          case 0:
                            component = id.isLocal() ? bitMap.getComponent(bitMap.getExistingComponentId(id.toStringWithoutVersion())) : bitMap.getComponent(id);

                            if (component) {
                              _context26.next = 3;
                              break;
                            }

                            return _context26.abrupt('return');

                          case 3:
                            if (!(component.origin && component.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED || component.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED)) {
                              _context26.next = 7;
                              break;
                            }

                            return _context26.abrupt('return', (_fsExtra || _load_fsExtra()).default.remove((_path || _load_path()).default.join(_this9.getPath(), component.rootDir)));

                          case 7:
                            if (!(component.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED && deleteFiles)) {
                              _context26.next = 9;
                              break;
                            }

                            return _context26.abrupt('return', Promise.all(component.files.map(function (file) {
                              return (_fsExtra || _load_fsExtra()).default.remove(file.relativePath);
                            })));

                          case 9:
                          case 'end':
                            return _context26.stop();
                        }
                      }
                    }, _callee26, _this9);
                  }));

                  return function (_x67) {
                    return _ref33.apply(this, arguments);
                  };
                }())));

              case 1:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee27, this);
      }));

      function removeComponentFromFs(_x64, _x65, _x66) {
        return _ref32.apply(this, arguments);
      }

      return removeComponentFromFs;
    }()
    /**
     * resolveLocalComponentIds - method is used for resolving local component ids
     * imported = bit.remote/utils/is-string
     * local = utils/is-string
     * if component is imported then cant remove version only component
     * @param {BitIds} bitIds - list of remote component ids to delete
     * @param {BitMap} bitMap - delete component that are used by other components.
     * @param {boolean} deleteFiles - delete component that are used by other components.
     */

  }, {
    key: 'resolveLocalComponentIds',
    value: function resolveLocalComponentIds(bitIds, bitMap) {
      return bitIds.map(function (id) {
        var realName = bitMap.getExistingComponentId(id.toStringWithoutVersion());
        if (!realName) return id;
        var component = bitMap.getComponent(realName);
        if (component && (component.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED || component.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED)) {
          var realId = (_bitId || _load_bitId()).BitId.parse(realName);
          realId.version = (_constants || _load_constants()).LATEST_BIT_VERSION;
          return realId;
        }
        return id;
      });
    }

    /**
     * cleanBitMapAndBitJson - clean up removed components from bitmap and bit.json file
     * @param {BitMap} bitMap - list of remote component ids to delete
     * @param {BitIds} componensToRemoveFromFs - delete component that are used by other components.
     * @param {BitIds} removedDependencies - delete component that are used by other components.
     */

  }, {
    key: 'cleanBitMapAndBitJson',
    value: function () {
      var _ref34 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee28(bitMap, componensToRemoveFromFs, removedDependencies) {
        var bitJson;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                bitJson = this.bitJson;

                bitMap.removeComponents(componensToRemoveFromFs);
                bitMap.removeComponents(removedDependencies);
                componensToRemoveFromFs.map(function (x) {
                  return delete bitJson.dependencies[x.toStringWithoutVersion()];
                });
                bitJson.write({ bitDir: this.projectPath });
                _context28.next = 7;
                return bitMap.write();

              case 7:
                return _context28.abrupt('return', _context28.sent);

              case 8:
              case 'end':
                return _context28.stop();
            }
          }
        }, _callee28, this);
      }));

      function cleanBitMapAndBitJson(_x68, _x69, _x70) {
        return _ref34.apply(this, arguments);
      }

      return cleanBitMapAndBitJson;
    }()
    /**
     * removeLocal - remove local (imported, new staged components) from modules and bitmap  accoriding to flags
     * @param {BitIds} bitIds - list of remote component ids to delete
     * @param {boolean} force - delete component that are used by other components.
     * @param {boolean} deleteFiles - delete component that are used by other components.
     */

  }, {
    key: 'removeLocal',
    value: function () {
      var _ref35 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee30(bitIds, force, track, deleteFiles) {
        var _this10 = this;

        var bitMap, modifiedComponents, regularComponents, resolvedIDs, _ref37, removedComponentIds, missingComponents, dependentBits, removedDependencies, componensToRemoveFromFs;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                _context30.next = 2;
                return this.getBitMap();

              case 2:
                bitMap = _context30.sent;
                modifiedComponents = [];
                regularComponents = [];
                resolvedIDs = this.resolveLocalComponentIds(bitIds, bitMap);

                if (!(_ramda || _load_ramda()).default.isEmpty(resolvedIDs)) {
                  _context30.next = 8;
                  break;
                }

                return _context30.abrupt('return', new (_componentRemove || _load_componentRemove()).RemovedLocalObjects());

              case 8:
                if (force) {
                  _context30.next = 11;
                  break;
                }

                _context30.next = 11;
                return Promise.all(resolvedIDs.map(function () {
                  var _ref36 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee29(id) {
                    var componentStatus;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee29$(_context29) {
                      while (1) {
                        switch (_context29.prev = _context29.next) {
                          case 0:
                            _context29.next = 2;
                            return _this10.getComponentStatusById(id);

                          case 2:
                            componentStatus = _context29.sent;

                            if (componentStatus.modified) modifiedComponents.push(id);else regularComponents.push(id);

                          case 4:
                          case 'end':
                            return _context29.stop();
                        }
                      }
                    }, _callee29, _this10);
                  }));

                  return function (_x75) {
                    return _ref36.apply(this, arguments);
                  };
                }()));

              case 11:
                _context30.next = 13;
                return this.scope.removeMany(force ? resolvedIDs : regularComponents, force, true);

              case 13:
                _ref37 = _context30.sent;
                removedComponentIds = _ref37.removedComponentIds;
                missingComponents = _ref37.missingComponents;
                dependentBits = _ref37.dependentBits;
                removedDependencies = _ref37.removedDependencies;
                componensToRemoveFromFs = removedComponentIds.filter(function (id) {
                  return id.version === (_constants || _load_constants()).LATEST_BIT_VERSION;
                });

                if ((_ramda || _load_ramda()).default.isEmpty(removedComponentIds)) {
                  _context30.next = 24;
                  break;
                }

                _context30.next = 22;
                return this.removeComponentFromFs(componensToRemoveFromFs, bitMap, deleteFiles);

              case 22:
                _context30.next = 24;
                return this.removeComponentFromFs(removedDependencies, bitMap, false);

              case 24:
                if (!((!track || deleteFiles) && !(_ramda || _load_ramda()).default.isEmpty(removedComponentIds))) {
                  _context30.next = 27;
                  break;
                }

                _context30.next = 27;
                return this.cleanBitMapAndBitJson(bitMap, componensToRemoveFromFs, removedDependencies);

              case 27:
                return _context30.abrupt('return', new (_componentRemove || _load_componentRemove()).RemovedLocalObjects(removedComponentIds, missingComponents, modifiedComponents, dependentBits, removedDependencies));

              case 28:
              case 'end':
                return _context30.stop();
            }
          }
        }, _callee30, this);
      }));

      function removeLocal(_x71, _x72, _x73, _x74) {
        return _ref35.apply(this, arguments);
      }

      return removeLocal;
    }()
  }, {
    key: 'addRemoteAndLocalVersionsToDependencies',
    value: function () {
      var _ref38 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee31(component, loadedFromFileSystem) {
        var modelDependencies, mainComponentFromModel, dependenciesIds, localDependencies, remoteVersionsDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee31$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`addRemoteAndLocalVersionsToDependencies for ${component.id.toString()}`);
                modelDependencies = [];

                if (!loadedFromFileSystem) {
                  _context31.next = 12;
                  break;
                }

                _context31.prev = 3;
                _context31.next = 6;
                return this.scope.loadRemoteComponent(component.id);

              case 6:
                mainComponentFromModel = _context31.sent;

                modelDependencies = mainComponentFromModel.dependencies;
                _context31.next = 12;
                break;

              case 10:
                _context31.prev = 10;
                _context31.t0 = _context31['catch'](3);

              case 12:
                dependenciesIds = component.dependencies.map(function (dependency) {
                  return dependency.id;
                });
                _context31.next = 15;
                return this.scope.latestVersions(dependenciesIds);

              case 15:
                localDependencies = _context31.sent;
                _context31.next = 18;
                return this.scope.fetchRemoteVersions(dependenciesIds);

              case 18:
                remoteVersionsDependencies = _context31.sent;

                component.dependencies.forEach(function (dependency) {
                  var dependencyIdWithoutVersion = dependency.id.toStringWithoutVersion();
                  var removeVersionId = remoteVersionsDependencies.find(function (remoteId) {
                    return remoteId.toStringWithoutVersion() === dependencyIdWithoutVersion;
                  });
                  var localVersionId = localDependencies.find(function (localId) {
                    return localId.toStringWithoutVersion() === dependencyIdWithoutVersion;
                  });
                  var modelVersionId = modelDependencies.find(function (modelDependency) {
                    return modelDependency.id.toStringWithoutVersion() === dependencyIdWithoutVersion;
                  });
                  dependency.remoteVersion = removeVersionId ? removeVersionId.version : null;
                  dependency.localVersion = localVersionId ? localVersionId.version : null;
                  dependency.currentVersion = modelVersionId ? modelVersionId.id.version : dependency.id.version;
                });

              case 20:
              case 'end':
                return _context31.stop();
            }
          }
        }, _callee31, this, [[3, 10]]);
      }));

      function addRemoteAndLocalVersionsToDependencies(_x76, _x77) {
        return _ref38.apply(this, arguments);
      }

      return addRemoteAndLocalVersionsToDependencies;
    }()
  }, {
    key: 'installNpmPackages',
    value: function () {
      var _ref39 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee32(componentsWithDependencies) {
        var verbose = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var packageManager, packageManagerArgs, packageManagerProcessOptions, useWorkspaces, componentsWithDependenciesFlatten, componentDirs, results;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                packageManager = this.bitJson.packageManager;
                packageManagerArgs = this.bitJson.packageManagerArgs;
                packageManagerProcessOptions = this.bitJson.packageManagerProcessOptions;
                useWorkspaces = this.bitJson.useWorkspaces;

                // if dependencies are installed as bit-components, go to each one of the dependencies and install npm packages
                // otherwise, if the dependencies are installed as npm packages, npm already takes care of that

                componentsWithDependenciesFlatten = (_ramda || _load_ramda()).default.flatten(componentsWithDependencies.map(function (oneComponentWithDependencies) {
                  return oneComponentWithDependencies.component.dependenciesSavedAsComponents ? [oneComponentWithDependencies.component].concat(_toConsumableArray(oneComponentWithDependencies.dependencies)) : [oneComponentWithDependencies.component];
                }));
                componentDirs = componentsWithDependenciesFlatten.map(function (component) {
                  return component.writtenPath;
                });

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_INSTALL_NPM_DEPENDENCIES);

                // don't pass the packages to npmClient.install function.
                // otherwise, it'll try to npm install the packages in one line 'npm install packageA packageB' and when
                // there are mix of public and private packages it fails with 404 error.
                // passing an empty array, results in installing packages from the package.json file
                _context32.next = 9;
                return (_npmClient || _load_npmClient()).default.install({
                  modules: [],
                  packageManager,
                  packageManagerArgs,
                  packageManagerProcessOptions,
                  useWorkspaces,
                  dirs: componentDirs,
                  rootDir: this.getPath(),
                  verbose
                });

              case 9:
                results = _context32.sent;


                (_loader || _load_loader()).default.stop();
                if (!Array.isArray(results)) {
                  results = [results];
                }
                results.forEach(function (result) {
                  if (result) (_npmClient || _load_npmClient()).default.printResults(result);
                });

              case 13:
              case 'end':
                return _context32.stop();
            }
          }
        }, _callee32, this);
      }));

      function installNpmPackages(_x79) {
        return _ref39.apply(this, arguments);
      }

      return installNpmPackages;
    }()
  }, {
    key: 'testerId',
    get: function get() {
      return (_bitId || _load_bitId()).BitId.parse(this.bitJson.testerId);
    }
  }, {
    key: 'compilerId',
    get: function get() {
      return (_bitId || _load_bitId()).BitId.parse(this.bitJson.compilerId);
    }
  }, {
    key: 'driver',
    get: function get() {
      if (!this._driver) {
        this._driver = (_driver || _load_driver()).Driver.load(this.bitJson.lang);
      }
      return this._driver;
    }
  }, {
    key: 'dirStructure',
    get: function get() {
      if (!this._dirStructure) {
        this._dirStructure = new (_dirStructure || _load_dirStructure()).default(this.bitJson.componentsDefaultDirectory, this.bitJson.dependenciesDirectory);
      }
      return this._dirStructure;
    }
  }], [{
    key: 'getRegistryPrefix',
    value: function getRegistryPrefix() {
      return (0, (_globalConfig || _load_globalConfig()).getSync)((_constants || _load_constants()).CFG_REGISTRY_DOMAIN_PREFIX) || (_constants || _load_constants()).DEFAULT_REGISTRY_DOMAIN_PREFIX;
    }
  }, {
    key: 'getNodeModulesPathOfComponent',
    value: function getNodeModulesPathOfComponent(bindingPrefix, id) {
      if (!id.scope) throw new Error(`Failed creating a path in node_modules for ${id}, as it does not have a scope yet`);
      // Temp fix to support old components before the migraion has been running
      bindingPrefix = bindingPrefix === 'bit' ? '@bit' : bindingPrefix;
      return (_path || _load_path()).default.join('node_modules', bindingPrefix, [id.scope, id.box, id.name].join((_constants || _load_constants()).NODE_PATH_SEPARATOR));
    }
  }, {
    key: 'getComponentIdFromNodeModulesPath',
    value: function getComponentIdFromNodeModulesPath(requirePath, bindingPrefix) {
      requirePath = (0, (_utils || _load_utils()).pathNormalizeToLinux)(requirePath);
      // Temp fix to support old components before the migraion has been running
      bindingPrefix = bindingPrefix === 'bit' ? '@bit' : bindingPrefix;
      var prefix = requirePath.includes('node_modules') ? `node_modules/${bindingPrefix}/` : `${bindingPrefix}/`;
      var withoutPrefix = requirePath.substr(requirePath.indexOf(prefix) + prefix.length);
      var componentName = withoutPrefix.includes('/') ? withoutPrefix.substr(0, withoutPrefix.indexOf('/')) : withoutPrefix;
      var pathSplit = componentName.split((_constants || _load_constants()).NODE_PATH_SEPARATOR);
      if (pathSplit.length < 3) throw new Error(`require statement ${requirePath} of the bit component is invalid`);

      var name = pathSplit[pathSplit.length - 1];
      var box = pathSplit[pathSplit.length - 2];
      var scope = pathSplit.length === 3 ? pathSplit[0] : `${pathSplit[0]}.${pathSplit[1]}`;
      return new (_bitId || _load_bitId()).BitId({ scope, box, name }).toString();
    }
  }, {
    key: 'create',
    value: function create() {
      var projectPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();

      return this.ensure(projectPath);
    }
  }, {
    key: 'ensure',
    value: function ensure() {
      var projectPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();

      var scopeP = (_scope || _load_scope()).Scope.ensure((_path || _load_path()).default.join(projectPath, (_constants || _load_constants()).BIT_HIDDEN_DIR));
      var bitJsonP = (_consumerBitJson || _load_consumerBitJson()).default.ensure(projectPath);

      return Promise.all([scopeP, bitJsonP]).then(function (_ref40) {
        var _ref41 = _slicedToArray(_ref40, 2),
            scope = _ref41[0],
            bitJson = _ref41[1];

        return new Consumer({
          projectPath,
          created: true,
          scope,
          bitJson
        });
      });
    }
  }, {
    key: 'createWithExistingScope',
    value: function () {
      var _ref42 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee33(consumerPath, scope) {
        var bitJson;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee33$(_context33) {
          while (1) {
            switch (_context33.prev = _context33.next) {
              case 0:
                if (!(0, (_consumerLocator || _load_consumerLocator()).pathHasConsumer)(consumerPath)) {
                  _context33.next = 2;
                  break;
                }

                return _context33.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).ConsumerAlreadyExists()));

              case 2:
                _context33.next = 4;
                return (_consumerBitJson || _load_consumerBitJson()).default.ensure(consumerPath);

              case 4:
                bitJson = _context33.sent;
                return _context33.abrupt('return', new Consumer({
                  projectPath: consumerPath,
                  created: true,
                  scope,
                  bitJson
                }));

              case 6:
              case 'end':
                return _context33.stop();
            }
          }
        }, _callee33, this);
      }));

      function createWithExistingScope(_x82, _x83) {
        return _ref42.apply(this, arguments);
      }

      return createWithExistingScope;
    }()
  }, {
    key: 'load',
    value: function () {
      var _ref43 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee34(currentPath) {
        var projectPath, scopeP, bitJsonP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                projectPath = (0, (_consumerLocator || _load_consumerLocator()).locateConsumer)(currentPath);

                if (projectPath) {
                  _context34.next = 3;
                  break;
                }

                return _context34.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).ConsumerNotFound()));

              case 3:
                if (!(!(0, (_consumerLocator || _load_consumerLocator()).pathHasConsumer)(projectPath) && (0, (_consumerLocator || _load_consumerLocator()).pathHasBitMap)(projectPath))) {
                  _context34.next = 6;
                  break;
                }

                _context34.next = 6;
                return Consumer.create(currentPath).then(function (consumer) {
                  return consumer.write();
                });

              case 6:
                scopeP = (_scope || _load_scope()).Scope.load((_path || _load_path()).default.join(projectPath, (_constants || _load_constants()).BIT_HIDDEN_DIR));
                bitJsonP = (_consumerBitJson || _load_consumerBitJson()).default.load(projectPath);
                return _context34.abrupt('return', Promise.all([scopeP, bitJsonP]).then(function (_ref44) {
                  var _ref45 = _slicedToArray(_ref44, 2),
                      scope = _ref45[0],
                      bitJson = _ref45[1];

                  return new Consumer({
                    projectPath,
                    bitJson,
                    scope
                  });
                }));

              case 9:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));

      function load(_x84) {
        return _ref43.apply(this, arguments);
      }

      return load;
    }()
  }]);

  return Consumer;
}();

exports.default = Consumer;